/*
!=======================================================================
!
!  PROGRAM  PHASE-Viewer  (PHASE-Viewer 2014.01 ver.3.3.0)
!
!  Created on ----
!  AUTHOR(S): KOGA, Junichiro
!  File : DosParser.java
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!=======================================================================
 */
package ciss.phase_viewer.common;

import java.util.StringTokenizer;

public class DosParser extends OldOutputParser {

    /** number of columns */
    private int numColumns;
    private int numColumnsMax = 0;

    /** number of rows */
    private int numRows;

    /**
     * 初期化を行い(親クラスのコンストラクター), おしきせのヘッダーを足しこむ.
     * 
     * @param filename
     *            パースすべき状態密度ファイル.
     */
    public DosParser(String filename) {
        super(filename);
        String cr = OldOutputParser.CR;
        addHeader("# filename: " + filename + cr);
        addHeader("# density of states ");
    }

    /**
     * F_DOSファイルの各行をパースする. 各要素を, カラム保持用Vectorに格納.
     * 
     * @param str
     *            パースすべき行.
     */
    public void parseString(String str) {
        StringTokenizer st = new StringTokenizer(str);
        String strdata = new String();
        boolean bloopisData = false;
        numColumns = st.countTokens();
        if (numColumns >= numColumnsMax) {
            setNumColumns(numColumns);
            numColumnsMax = numColumns;
        }

        for (int i = 0; i < getNumColumns(); i++) {
            if (st.hasMoreTokens()) {
                strdata = st.nextToken();
            } else {
                break;
            }
            if (str.trim().startsWith("No")) {
                addColumnName(strdata);
                bloopisData = false;
            } else if (str.toLowerCase().trim().startsWith("end")) {
                bloopisData = false;
            } else {
                addDataColumn(strdata);
                bloopisData = true;
            }
        }
        if (bloopisData) {
            addDataRow();
        }
    }
}
